#version 330                                                                        
                                                                                    
layout(points) in;                                                                  
layout(triangle_strip) out;                                                         
layout(max_vertices = 4) out;                                                       
                                                                                    
uniform mat4 VP;                                                                   
uniform vec3 cameraPos;                                                            
uniform float gBillboardSize;         

in vec2 coords[];                                              
                                                                                    
out vec2 TexCoord;
                                                                                    
void main()                                                                         
{                                                                                   
    vec3 Pos = gl_in[0].gl_Position.xyz;
	//gCurrentFrame = vCurrentFrame[0];                            
    vec3 toCamera = normalize(cameraPos - Pos);
    vec3 up = vec3(0.0, 1.0, 0.0);
    vec3 right = cross(toCamera, up);
	up = cross(right, toCamera) * gBillboardSize;
	right *= gBillboardSize;
                                                                                    
    Pos -= 0.5*right;
	Pos -= 0.5*up;                                                                   
    gl_Position = VP * vec4(Pos, 1.0);
    TexCoord = coords[0] + vec2(0.0, 0.0);                                                      
    EmitVertex();                                                                   
                                                                                    
    Pos.y += gBillboardSize;                                                        
    gl_Position = VP * vec4(Pos, 1.0);                                             
    TexCoord = coords[0] + 0.25 * vec2(0.0, 1.0);                                                      
    EmitVertex();                                                                   
                                                                                    
    Pos.y -= gBillboardSize;                                                        
    Pos += right;                                                                   
    gl_Position = VP * vec4(Pos, 1.0);                                             
    TexCoord = coords[0] + 0.25 * vec2(1.0, 0.0);                                                      
    EmitVertex();                                                                   
                                                                                    
    Pos.y += gBillboardSize;                                                        
    gl_Position = VP * vec4(Pos, 1.0);                                             
    TexCoord = coords[0] + 0.25 * vec2(1.0, 1.0);                                                      
    EmitVertex();                                                                   
                                                                                    
    EndPrimitive();                                                                 
}                                                                                   
